#!/usr/bin/env python

import os, re

from collections import OrderedDict

def readFasta_dict(InfileNameFN):
    Infile = open(InfileNameFN, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line
    Infile.close()
    return seqDictFN

def get_sequences():
    seqDictFN1  = OrderedDict()

    for dir in dirs:
        #if re.search("Onna", dir) or re.search("Miyako", dir):
        if re.search("res", dir):
            #print (dir)
    
            files = os.listdir(targetDir + "/" + dir)
            #print (files)
    
            seqfile = ""
            for file in files:
                if re.search("Circularized", file):
                    seqfile = file
                    break
                elif re.search("Contigs", file):
                    seqfile = file
                    break
            match = re.search("_([^_\.]+_[^_\.]+)\.fasta$", file)
            speciesID = match.group(1)
            InfileName = targetDir + "/" + dir + "/" + file
            seqDict = readFasta_dict(InfileName)
            firstSequence = list(seqDict.values())[0]
            #print("firstSequence", firstSequence)
            #exit()
            seqDictFN1[speciesID] = firstSequence

    '''
    for file in files:
        if file.startswith("Circularized"):
            match = re.search("_([^_\.]+_[^_\.]+)\.fasta$", file)
            speciesID = match.group(1)
            #print(file)
            #print(speciesID)
            #continue
            InfileName = targetDir + "/" + file
            seqDict = readFasta_dict(InfileName)
            firstSequence = list(seqDict.values())[0]
            #print("firstSequence", firstSequence)
            #exit()
            seqDictFN1[speciesID] = firstSequence
    '''

    return(seqDictFN1)


def arrange_starting(seqDictFN):
    seqDictFN2  = OrderedDict()
    for name, seq_all in seqDictFN.items():
        #print(name)
        if re.search(seq_start, seq_all):
            match = re.search("(^.*)" + seq_start + "(.*$)", seq_all)
            seq_former = match.group(1)
            seq_latter = match.group(2)
            seq_all_mod = seq_all + seq_latter + seq_former
            seqDictFN2[name] = seq_all_mod
        else:
            seqDictFN2[name] = "#############NotFound#############:" + seq_all
    return seqDictFN2

############## 

out = open("010out.txt", "w")
targetDir = "data_cluster"
#seq_start = "TTTTTAACCGTTGGACTAACCTC"  ## tRNA-Phe
seq_start = "TTTTTAACCGTTGGACTAACCTC"  ## tRNA-Phe


dirs = os.listdir(path=targetDir)
seqDict = get_sequences()
seqDict = arrange_starting(seqDict)

out = open("010out.txt", "w")
for name, seq in seqDict.items():
    out.write(">" + name + "\n")
    out.write(seq + "\n")
out.close()

